#include <stdio.h>
#include <string.h>  /* for strlen() */
#include "stack.h"
#include <stdlib.h>  /* for dynamic allocation */
  // Author: Robert I. Pitts <rip@cs.bu.edu>
/************************ Funktsioonid **********************/
void StackInit(stackT *stackP, int maxSize)
{stackElementT *newContents;
 /* uus element, new element */
newContents = (stackElementT *)malloc(sizeof(stackElementT) * maxSize);
if (newContents == NULL) {
    fprintf(stderr, "Ei ole piisavalt ruumi pinule,there is not enough space\n");
    exit(1);  /* Lahkun veateatega,leaving with an error message */
  }

  stackP->contents = newContents;
  stackP->maxSize = maxSize;
  stackP->top = -1;  /* tyhi  pinu,empty stack*/
}
void StackDestroy(stackT *stackP)
{/* massiivi kaotamine,array deletion */
  free(stackP->contents);
  stackP->contents = NULL;
  stackP->maxSize = 0;
  stackP->top = -1;  /* tyhi, empty*/
}
void StackPush(stackT *stackP, stackElementT element)
{
  if (StackIsFull(stackP)) {
    fprintf(stderr, "Ei saa elemente panna pinusse - on tis,stack is full \n");
    exit(1);  /* Lahkun veateatega, leaving with an error message */
  }
 /* Panen elemendi pinusse,massiivi, put the element into the stack, an array*/
 stackP->contents[++stackP->top] = element;
  
}
stackElementT StackPop(stackT *stackP)
{if (StackIsEmpty(stackP)) {
    fprintf(stderr, "Ei saa elemente pinust votta - on tyhi, stack is empty\n");
    exit(1);  /*  Lahkun,veateadega, I'm leaving with an error message */}
  return stackP->contents[stackP->top--];
}
int StackIsEmpty(stackT *stackP)
{ return stackP->top < 0;}
int StackIsFull(stackT *stackP)
{return stackP->top >= stackP->maxSize - 1;}
/************************ Peaprogramm **********************/
int main(void)
{
  stackT stack;    /* pinu symbolitele,stringile, stack for symbols, string */
  char str[101];   /* kasutaja strigile muutuja kirjeldus, for users strig variable description */
//viit strigis liikumiseks,stringi sisestus* mitte rohkem kui 100 symbolit 
//pointer to move within a string, string input * up to 100 characters
  char *traverse; printf("Sisesta string: insert string: ");
  gets(str);  /* loe rida, read row */
  /* Initializeeri pinu ja seda piisavalt suurena. Initialize the stack and make it large enough*/
  StackInit(&stack, strlen(str));
//Liigu strigi pidi ja aseta iga symbol pinusse
//move along the string and place each symbol in the stack
  for (traverse = str; *traverse != '\0'; traverse++) {
    StackPush(&stack, *traverse);
    printf("%c", *traverse);
    printf("\n"); /*pinusse tulekud*/ 
  } /*Vota iga symbol pinust ja prindi*/
   printf("\nPinust  valjastatud symbolid:printout symbols: ");
 while (!StackIsEmpty(&stack)) {
    printf("%c", StackPop(&stack));
  }
printf("\n");
StackDestroy(&stack);
  getchar();
  return 0;
}

